tic;
Sdim = NVU+NPU;
i1 = zeros (50*Sdim, 1); 
j1 = zeros(50*Sdim, 1); 
i2 = zeros (50*Sdim, 1); 
j2 = zeros(50*Sdim, 1); 

p1 = zeros(50*Sdim, 1);
s1 = zeros(50*Sdim, 1);

number1=0;
number2=0;
number3=0;



% loop over all elements and build local matrices
for itrg = 1:size(elnode,1)

      
          Alocal = [ ] ;
          RHSloc = [ ] ;
          % Set up unknown solution vector mapping to global velocity vector
          if strcmp(vel_bas_type, 'CtsQuad') == 1
                Vstart = [2*(elnode(itrg,1:3) - 1) + 1 , 2*(elnode(itrg,4:6) + nVert - 1) + 1];
                GlTrgVe = reshape([Vstart ; Vstart+1],[12,1]) ;

          end
          % and for pressure
          Pstart = elnode(itrg, 1:3) ;
          GlTrgPr = Pstart.' ;

          % these are the global dof numbers for the local dof
          localUnk = [ GlTrgVe ; NVU + GlTrgPr ] ;
          
          % Evaluate basis functions
          ten1a=basisValues(:,:,itrg);
          Gradtrue = gradBasisValues(:,:,:,itrg);

          %%%%%%%%%%%%%%%%
          % Evaluate the integrals.

          %% Assemble the pieces for the MOMENTUM EQUATION

          %% Local Stiffness (in deformation form)
          matA11_a = inner_prod_Grad_ten1_Grad_ten1(itrg, 'quad_75', vel_bas_type, vel_bas_type) ;

          % Pressure (and cons mass if you transpose)
          LPres = -1.0* inner_prod_Div_ten1_ten0(itrg,'quad_75', ...
             'OneScalFun', vel_bas_type, pre_bas_type) ;     



          for count=1:size(GlTrgVe,1)
           for count1=1:size(GlTrgPr,1)
                number1=number1+1;
                i1(number1) = GlTrgVe(count);
                j1(number1) = GlTrgPr(count1);
                p1(number1) = LPres(count, count1);   
           end
          end

          for count=1:size(GlTrgVe,1)
           for count1=1:size(GlTrgVe,1)
                number2=number2+1;
                i2(number2) = GlTrgVe(count);
                j2(number2) = GlTrgVe(count1);
                s1(number2) = matA11_a(count, count1);
           end
          end

 


   
end

PressureMatrix = sparse(i1(1:number1), j1(1:number1), p1(1:number1), NVU,NPU) ;
StiffnessMatrix = sparse(i2(1:number2), j2(1:number2), s1(1:number2), NVU, NVU) ;


